﻿package
{
	import flash.display.MovieClip;
		
	public class CBug extends MovieClip
	{
		public var _cookie:CCookie = null;
		public var _targetCookie:CCookie = null;
		var _cookieContainer:Array;
		var _gameMain:CGameMain;
				
		var _type:Number;
		var _armor:Number;
		
		var _speed:Number = 1.0 + Math.random()/1.5;
		var _spawnX:Number, _spawnY:Number;
		var _targetX:Number, _targetY:Number;	
		
		var _chainArmor:CBugChainArmor = null;
		var _plateArmor:CBugPlateArmor = null;
			
		public function removeArmor():void
		{
			if(_armor == 0) return;
			
			if(_armor == 1)
			{
				this.removeChild(_chainArmor);
				_chainArmor=null;
			}
			
			if(_armor == 2)
			{
				this.removeChild(_plateArmor);
				_plateArmor=null;
			}	
			
			_armor --;
		}
		
		public function CBug(gameMain:CGameMain, cookieContainer:Array, x:Number, y:Number, type:Number, armor:Number)
		{
			super();
			
			_cookieContainer = cookieContainer;
			_gameMain = gameMain;
			
			this.x = x;
			this.y = y;
			_spawnX = x;
			_spawnY = y;		
			
			_type = type;			
			if(type == 2) _speed *= 1.5;
			
			_armor = armor;
			if(_armor >= 1)
			{
				_chainArmor = new CBugChainArmor();
				this.addChild(_chainArmor);
			}
			if(_armor >= 2) 
			{
				_plateArmor = new CBugPlateArmor();
				this.addChild(_plateArmor);
			}
		}		
		
		public function frameMove():Number
		{		
			// 프레임 처리  녹색 벌레 1~20  붉은 벌레 21~40
			if(_type == 1)
			{
				if(this.currentFrame >= 20) this.gotoAndPlay(1); 
			}
			else
			if(_type == 2)
			{
				if(this.currentFrame >= 40) this.gotoAndPlay(21);
			}
			
			var dx:Number;
			var dy:Number;
			var length:Number;
			
			// 과자를 하나 집었다면 원접으로 돌아가자!
			if(_cookie)	
			{
				// 태어난 곳으로 ㄱㄱ!				
				dx = _spawnX - this.x;
				dy = _spawnY - this.y;
				
				_cookie.x = this.x;
				_cookie.y = this.y;
				
				length = Math.sqrt(dx*dx + dy*dy);
				if(length<3.0) 
				{															
					return 1;
				}
				else
				{
					// 아니면 이동
					dx /= length;
					dy /= length;
					
					this.x += dx * _speed;
					this.y += dy * _speed;					
					
					this.rotation = 360-(Math.atan2(dx, dy) + Math.PI) * 57.29577951;
				}
				
				return 0;
			}
			
			
			// 아직 쿠키를 잡지 못했다면 목표를 하나 잡고 그것을 향해 ㄱㄱ!
			if(_targetCookie==null)
			{
				var i:Number;
				
				if(_cookieContainer.length > 0)
				{
					for(i=0;i<20;i++)
					{
						_gameMain._searchIndex++;
						if(_gameMain._searchIndex >= _cookieContainer.length) _gameMain._searchIndex = 0;					
					
						// 아직 버그의 소유가 되지 않았다면..
						if(_cookieContainer[_gameMain._searchIndex]._bugFlag==0)
						{
							// 이걸 잡자!
							// 타겟 목표를 이걸로 잡자				
							_targetCookie = _cookieContainer[_gameMain._searchIndex];							
				
							break;
						}
					}
				}				
			}
			else
			{
				// 만약 누가 과자를 잡았다면 그것을 포기하고 다른 과자를 향해 간다.
				if(_targetCookie._bugFlag == 1)
				{
					_targetCookie = null;
					return 0;
				}	
				
				_targetX = _targetCookie.x;
				_targetY = _targetCookie.y;		
				
				dx = _targetX - this.x;
				dy = _targetY - this.y;			
				
				length = Math.sqrt(dx*dx + dy*dy);
				
				if(length<3.0)
				{
					_cookie=_targetCookie;
					_targetCookie = null;	
					
					// 쿠키를 벌레보다 위로 올려주어야 한다.
					var t:Number = _gameMain.getChildIndex(this);
					_gameMain.setChildIndex(this, _gameMain.getChildIndex(_cookie));
					_gameMain.setChildIndex(_cookie, t);
					
					_cookie._bugFlag = 1;
				}
				else
				{
					// 아니면 이동
					dx /= length;
					dy /= length;
					
					this.x += dx * _speed;
					this.y += dy * _speed;					
					
					this.rotation = 360-(Math.atan2(dx, dy) + Math.PI) * 57.29577951;
				}
			}	
			
			return 0;	
		}				
	}
}