﻿package
{
	import flash.display.*;
	import flash.events.*;
	import flash.media.Sound;
	import flash.net.*;
	import flash.net.URLLoader;
	import flash.text.*;
	import flash.system.*;
		
	public class CGameMain extends MovieClip
	{
		var _mode:Number = 0;
		var _nextBugTime:Number = 0;
		
		var _bugContainer:Array = new Array();
		var _cookieContainer:Array = new Array();
		var _effectContainer:Array = new Array();
		
		var _searchIndex:Number = 0;
				
		var _score:Number = 0;
		
		// 난이도 관련
		var _pastTime:Number = 0;
		
		// 사운드
		public var _soundOnOff:Boolean = true;
		var _soundMetal:CSoundMetal = new CSoundMetal();
		var _soundKill:CSoundKill = new CSoundKill();
		var _soundEnd:CSoundEnd = new CSoundEnd();
		
		var _soundOnOffButton:CSoundOnOff=null;
		
		// 페이스북 아이디 가져오기
		var paramObj:Object = stage.loaderInfo.parameters;
		var _facebookuid:String = paramObj.facebookuid;
		
		public function CGameMain()
		{
			super();
			
			stage.addEventListener(Event.ENTER_FRAME, onEnterFrame);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			stage.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
			
			this.gotoAndPlay(1, "Title");			
		}
		
		private function onMouseDown(event:MouseEvent):void
		{
			var i:Number;
			var x:Number;
			var y:Number;
			
			if(_mode == 1)
			{
				// 충돌 체크 검사.
				for(i=0;i<_bugContainer.length;i++)
				{
					x = stage.mouseX - _bugContainer[i].x;
					y = stage.mouseY - _bugContainer[i].y;
					
					if(x * x + y * y < 28*28)
					{
						// 이펙트 추가
						var hit:CHit = new CHit();
						hit.x = _bugContainer[i].x;
						hit.y = _bugContainer[i].y;						
						hit._lifeTime = 0.5;		
						this.addChild(hit)	
						_effectContainer.push(hit);
						
						if(_bugContainer[i]._armor>0)
						{
							if(_soundOnOff)	_soundMetal.play();
							
							_bugContainer[i].removeArmor();
							_score+=3;
						}
						else
						{
							if(_soundOnOff)	_soundKill.play();
							
							if(_bugContainer[i]._type == 1)
								_score += 10;
							else
								_score += 15;
							
							// 시체 만들어주자
							var bugdead:CBugDead = new CBugDead();
							bugdead.x = _bugContainer[i].x;
							bugdead.y = _bugContainer[i].y;
							bugdead.rotation = _bugContainer[i].rotation;
							bugdead._lifeTime = 5.0;
							if(_bugContainer[i]._cookie != null)
								this.addChildAt(bugdead, this.getChildIndex(_bugContainer[i]._cookie));
							else
								this.addChild(bugdead)							
							_effectContainer.push(bugdead);
							
							// 쿠키를 다시 놓아두어야 한다.
							if(_bugContainer[i]._cookie != null)
								_bugContainer[i]._cookie._bugFlag = 0;
							
							this.removeChild(_bugContainer[i]);
							_bugContainer.splice(i, 1);
							i--;							
						}						
						
						scoreText.text = _score.toString();							
						return;
					}
				}				
			}
		}
		
		private function onMouseUp(event:MouseEvent):void
		{
			var i:Number;
			var x:Number;
			var y:Number;
			
			if(_mode == 0) 
			{
				_mode = 1;
				_nextBugTime = 3;
				this.gotoAndStop(1, "Game");
				
				_score = 0;
				scoreText.text = _score.toString();		
				scoreText.selectable = false;
				score.selectable = false;
				cookiesText.selectable = false;
				cookies.selectable = false;
				
				cookiesText.text = "20";
				
				_pastTime = 0;
				
				// 쿠키 생성				
				for(i=0;i<20;i++)
				{
					x = 168 + Math.random() * 144;
					y = 144 + Math.random() * 32;
					
					var cookie:CCookie = new CCookie(x, y);
					this.addChild(cookie);
					_cookieContainer.push(cookie);
				}
			}
			else			
			if(_mode == 2)
			{
				_mode = 0;
				this.gotoAndPlay(1, "Title");				
			}
		}
		
		private function createBug()
		{
			var angle:Number = Math.random() * (Math.PI * 2);
			
			var x:Number =  350 * Math.sin(angle) + 240;
			var y:Number = -350 * Math.cos(angle) + 160;
			
			var type:Number = 1;
			var armor:Number = 0;
			if(_pastTime>20) 
			{
				if(Math.random()>=0.5) type = 2;
			}
			
			if(_pastTime>60)
			{
				if(Math.random()>=0.5)
				{
					armor = 1;	
				}
				else
				{
					if(Math.random()>=0.5) armor = 2;
				}
			}
			else
			if(_pastTime>40)
			{
				if(Math.random()>=0.7) armor = 1;
			}			
			
			
			var bug:CBug = new CBug(this, _cookieContainer, x, y, type, armor);
			this.addChild(bug);
			_bugContainer.push(bug);
		}
		
		private function removeCookie(cookie:CCookie)
		{
			var idx:Number = _cookieContainer.indexOf(cookie);
			this.removeChild(_cookieContainer[idx]);
			_cookieContainer.splice(idx, 1);
			
			var i:Number;
			for(i=0;i<_bugContainer.length;i++)
			{
				if(_bugContainer[i]._cookie == cookie)
				{
					_bugContainer[i]._cookie = null;					
				}
				
				if(_bugContainer[i]._targetCookie == cookie)
				{
					_bugContainer[i]._targetCookie = null;				
				}
			}			
			
			cookiesText.text = _cookieContainer.length.toString();
		}
		
		private function onEnterFrame(event:Event):void
		{
			var i:Number;
			
			if(_soundOnOffButton==null)
			{
				_soundOnOffButton = new CSoundOnOff(this)
				this.addChild(_soundOnOffButton);
				_soundOnOffButton.x = 24;
				_soundOnOffButton.y = 300;
				_soundOnOffButton.gotoAndStop(1);
			}
			else
			{				
				this.setChildIndex(_soundOnOffButton, this.numChildren-1);
			}
			
			if(_mode==0)
			{
				if(this.currentFrame >= 29)
					this.gotoAndPlay(1, "Title");
			}
			else
			if(_mode==1)
			{
				if(cookiesText)
					this.setChildIndex(cookiesText, this.numChildren-1);
				if(scoreText)
					this.setChildIndex(scoreText, this.numChildren-1);
				if(cookies)
					this.setChildIndex(cookies, this.numChildren-1);
				if(score)
					this.setChildIndex(score, this.numChildren-1);
				
				if(_cookieContainer.length == 0)
				{
					if(_soundOnOff)	_soundEnd.play();
					
					_mode = 2;
					this.gotoAndStop(1, "GameOver");
					
					// 기록 전달!
					var loader:URLLoader = new URLLoader();
					loader.dataFormat = URLLoaderDataFormat.VARIABLES;
					loader.load(new URLRequest("http://www.meteorstudio.com/rank/record.php?GameCode=FK&Score=" + _score + "&uid=" + _facebookuid));
					
					if(cookiesText)
						this.setChildIndex(cookiesText, 0);
					if(scoreText)
						this.setChildIndex(scoreText, 0);
					if(cookies)
						this.setChildIndex(cookies, 0);
					if(score)
						this.setChildIndex(score, 0);
					
					// 화면상의 남은 벌레들을 지워준다.
					for(i=0;i<_bugContainer.length;i++)
					{
						this.removeChild(_bugContainer[i]);
					}
					_bugContainer.splice(0);
					
					// 이펙트 제거
					for(i=0;i<_effectContainer.length;i++)
					{
						this.removeChild(_effectContainer[i]);
					}
					_effectContainer.splice(0);
					
					// 쿠키 제거
					for(i=0;i<_cookieContainer.length;i++)
					{
						this.removeChild(_cookieContainer[i]);
					}
					_cookieContainer.splice(0);
					return;
				}
				
				_nextBugTime -= 0.016;
				if(_nextBugTime <= 0)
				{
					// 버그 생성
					createBug();
					_nextBugTime = 0.5;
				}
				
				_pastTime += 0.016;
								
				for(i=0;i<_bugContainer.length;i++)
				{
					if(_bugContainer[i].frameMove())					
					{
						// 리스폰 위치에 도착했다면!						
						
						// 케익과 벌레 둘다 처리.
						removeCookie(_bugContainer[i]._cookie);
												
						this.removeChild(_bugContainer[i]);
						_bugContainer.splice(i, 1);
						i--;						
					}
				}
				
				for(i=0;i<_effectContainer.length;i++)
				{
					_effectContainer[i]._lifeTime -= 0.016;
					if(_effectContainer[i]._lifeTime <= 0)
					{
						this.removeChild(_effectContainer[i]);
						_effectContainer.splice(i, 1);
						i--;
					}
				}
			}
		}
	}
}