﻿package
{
	import flash.display.MovieClip;
	import flash.events.*;
	import flash.utils.*;
		
	public class CGameMain extends MovieClip
	{
		public var _card:Array = new Array();
		public var _cardIndex:Array = new Array();
		
		var _firstSelCard:int = -1;
		var _secondSelCard:int = -1;
		var _cardCount:int = 0;
		var _remainCard:int;
		
		var _mode:int = 0;
		
		var _startTime:Number;
		
		public function CGameMain()
		{
			super();	
			
			_cardCount = 24;
			_remainCard = _cardCount;
			createCard();		
			
			_startTime = getTimer();
			
			stage.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
			
			this.gotoAndStop(1);
		}
		
		public function createCard()
		{			
			// 카드 개수에 맞게 배열을 넣어준다.
			for(var i:int=0;i<_cardCount;i++)
			{
				_cardIndex[i] = int(i/2) + 1;
			}
			
			trace(_cardIndex);
			
			// 순차적인 카드 리스트를 적절하게 섞어 준다.
			for(i = 0;i<1000;i++)
			{
				var first:int = Math.random()*_cardCount;
				var second:int = Math.random()*_cardCount;
				
				var temp:int = _cardIndex[first];
				_cardIndex[first] = _cardIndex[second];
				_cardIndex[second] = temp;
			}
					
			// 카드위 의치를 세팅해준다.
			var x:Number = 64, y:Number = 64;
			for(i = 0;i<_cardCount;i++)
			{
				_card.push(new CCard());
				stage.addChild(_card[i]);
				
				_card[i].scaleX = 0.2;
				_card[i].scaleY = 0.2;
				_card[i].x = x;
				_card[i].y = y;
				_card[i].gotoAndStop(13);
				
				x += 64;
				if((i+1) % 4 == 0)
				{
					x = 64;
					y += 72;
				}
			}			
		}
		
		private function allClear():void
		{
			this.gotoAndStop(1, "Clear");
			_mode = 1;
			
			var clearTime:Number = (getTimer() - _startTime) / 1000;
			trace(clearTime);
			clearTimeText.text = clearTime.toString() + "sec.";
		}
		
		private function onTimer(event:TimerEvent):void
		{
			if( _cardIndex[_firstSelCard] == _cardIndex[_secondSelCard] )
			{
				// 만약 같다면 맞추었다고 처리 한다.
				stage.removeChild(_card[_firstSelCard]);
				stage.removeChild(_card[_secondSelCard]);
				
				_cardIndex[_firstSelCard] = -1;
				_cardIndex[_secondSelCard] = -1;
				
				_remainCard -= 2;
				
				if(_remainCard == 0)
				{
					allClear();
				}
			}
			else
			{
				// 아니라면 다시 카드를 뒤집는다.
				_card[_firstSelCard].gotoAndStop(13);
				_card[_secondSelCard].gotoAndStop(13);
			}
			
			_firstSelCard = -1;
			_secondSelCard = -1;
		}
		
		private function onMouseUp(event:MouseEvent):void
		{
			if(_mode == 1) 
			{
				this.gotoAndStop(1, "Game");
				_mode = 0;
				
				// 게임 다시 시작
				_cardCount = 24;
				_remainCard = _cardCount;
				createCard();
				
				_startTime = getTimer();
				return;
			}
			
			// 터치한 곳의 인덱스를 얻어낸다.
			var curIndex:int = -1;
			var x:Number = 64, y:Number = 64;
			for(var i:int = 0;i<_cardCount;i++)
			{
				if( (x - 32) < stage.mouseX && (x + 32) > stage.mouseX &&
					(y - 32) < stage.mouseY && (y + 32) > stage.mouseY)
				{
					curIndex = i;
					break;
				}
				
				x += 64;
				if((i+1) % 4 == 0)
				{
					x = 64;
					y += 72;
				}
			}
			
			if(curIndex==-1) return;
			if(_cardIndex[curIndex]==-1) return;
			
			if(_firstSelCard==-1) 
			{
				_firstSelCard = curIndex;	
				_card[_firstSelCard].gotoAndStop(_cardIndex[_firstSelCard]);
				return;
			}
			
			if(_secondSelCard==-1 && _firstSelCard != curIndex) 
			{
				_secondSelCard = curIndex;	
				_card[_secondSelCard].gotoAndStop(_cardIndex[_secondSelCard]);
				
				//0.5초에 뒤집은 두장의 카드를 비교할 수 있도록 타이머를 할당한다.				
				var timer:Timer = new Timer(500, 1);
				timer.addEventListener(TimerEvent.TIMER, onTimer);
				timer.start();
				return;
			}
		}
	}
}