package
{
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.net.*;
		
	public class CGameMain extends MovieClip
	{
		var myMobList:Array = new Array();
		var userBattleBtn = new CUserBattleBtn();
		var dungeonBattleBtn = new CDungeonBattleBtn();
		var levelBtnList:Array = new Array();
		var userBtnList:Array = new Array();
		
		public function CGameMain()
		{
			super();
			
			getMyMob();
			getNews();
			createButton();			
			
			this.gotoAndStop(1);
		}
		
		public function createButton()
		{
			userBattleBtn.x = 420;
			userBattleBtn.y = 350;
			userBattleBtn.setGameMain(this);
			this.addChild(userBattleBtn);
			
			dungeonBattleBtn.x = 500;
			dungeonBattleBtn.y = 350;
			dungeonBattleBtn.setGameMain(this);
			this.addChild(dungeonBattleBtn);
		}
		
		public function deleteButton()
		{
			this.removeChild(userBattleBtn);
			this.removeChild(dungeonBattleBtn);
		}
		
		public function getNews():void
		{
			var loader:URLLoader = new URLLoader();
			loader.dataFormat = URLLoaderDataFormat.TEXT;
			loader.addEventListener(Event.COMPLETE, getNewsComplete);
			loader.load(new URLRequest("http://www.meteorstudio.com/wbgame/getnews.php"));
		}
		
		private function getNewsComplete(event:Event):void
		{
			var loader:URLLoader = URLLoader(event.target);			
			NewsText.text = loader.data;
		}
		
		public function getMyMob():void
		{
			var loader:URLLoader = new URLLoader();
			loader.dataFormat = URLLoaderDataFormat.TEXT;
			loader.addEventListener(Event.COMPLETE, getMyMobComplete);
			loader.load(new URLRequest("http://www.meteorstudio.com/wbgame/getmymob.php"));
		}
		
		private function getMyMobComplete(event:Event):void
		{
			var loader:URLLoader = URLLoader(event.target);			
			var mobData:String = loader.data;
						
			// 문자열을 공백을 기준으로 자른다.
			var dataArray:Array = mobData.split(" ");
			var startX:Number = 50;
			var startY:Number = 200;
			for(var i:Number = 0; i<dataArray.length; i+=3)
			{				
				if(isNaN(dataArray[i+1])) break;
				
				// 몬스터 생성
				var mob:CMonster = new CMonster();
				mob.x = startX;
				mob.y = startY;
				mob.scaleX = 0.3;
				mob.scaleY = 0.3;
				mob.setMonsterInfo(	parseInt(dataArray[i+1]), 
									parseInt(dataArray[i+2]));
				
				myMobList.push(mob);				
				this.addChild(mob);
				
				startX += 70;
				if(startX>500) 
				{
					startX = 50;
					startY += 70;
				}
			}
		}
		
		public function deleteMyMob():void
		{
			for(var i:Number = 0; i<myMobList.length; i++)
			{
				this.removeChild(myMobList[i]);
			}
			
			myMobList.splice(0);	
		}
		
		public function enterUserBattle():void
		{
			trace("enterUserBattle");
			deleteButton();		
			deleteMyMob();
			
			this.gotoAndStop(1, "Battle");
			
			getMyFriendList();
		}
		
		public function enterDungeon():void
		{
			trace("enterDungeon");
			deleteButton();
			deleteMyMob();
			
			this.gotoAndStop(1, "Dungeon");
			
			createDungeonLevelBtn();
		}
		
		public function createDungeonLevelBtn():void
		{			
			trace("createDungeonLevelBtn");
			var startX:Number = 90;
			var startY:Number = 100;
			for(var i:Number = 0; i<15; i++)
			{				
				// 몬스터 생성
				var levelBtn:CLevelBtn = new CLevelBtn();
				levelBtn.x = startX;
				levelBtn.y = startY;				
				levelBtn.setGameMain(this);
				levelBtn.setLevel(i+1);
				
				this.addChild(levelBtn);
				levelBtnList.push(levelBtn);				
								
				startX += 90;
				if(startX>500) 
				{
					startX = 90;
					startY += 90;
				}
			}
		}
		
		public function deleteDungeonLevelBtn():void
		{
			for(var i:Number = 0; i<levelBtnList.length; i++)
			{
				this.removeChild(levelBtnList[i]);
			}
			
			levelBtnList.splice(0);	
		}
		
		public function startDungeonBattle(level:Number):void
		{
			var loader:URLLoader = new URLLoader();
			loader.dataFormat = URLLoaderDataFormat.TEXT;
			loader.addEventListener(Event.COMPLETE, dungeonBattleComplete);
			var url:String = new String;
			url += "http://www.meteorstudio.com/wbgame/dungeonbattle.php";
			url += "?level=" + level.toString();
			loader.load(new URLRequest(url));
		}
		
		private function dungeonBattleComplete(event:Event):void
		{
			deleteDungeonLevelBtn()
			
			this.gotoAndStop(1, "Info");			
			
			getMyMob();
			getNews();
			createButton();		
		}
		
		public function getMyFriendList():void
		{
			var loader:URLLoader = new URLLoader();
			loader.dataFormat = URLLoaderDataFormat.TEXT;
			loader.addEventListener(Event.COMPLETE, getMyFriendListComplete);
			loader.load(new URLRequest("http://www.meteorstudio.com/wbgame/getmyfriendlist.php"));
		}
		
		private function getMyFriendListComplete(event:Event):void
		{				
			var loader:URLLoader = URLLoader(event.target);			
			var friendData:String = loader.data;
						
			// 문자열을 콤마(,)를 기준으로 자른다.
			var dataArray:Array = friendData.split(",");			
			var startY:Number = 100;
			for(var i:Number = 0; i<dataArray.length; i+=3)
			{	
				if(dataArray[i+1] == null) break;
				if(parseInt(dataArray[i+2]) == 0) continue;
												
				// 유저 버튼
				var btn:CUserBtn = new CUserBtn();
				btn.x = 275;
				btn.y = startY;
				
				btn.setGameMain(this);
				btn.setInfo(dataArray[i+1]+"("+dataArray[i+2]+")");
				btn.setUID(dataArray[i]);
				btn.setMonsterCount(parseInt(dataArray[i+2]));
				
				userBtnList.push(btn);				
				this.addChild(btn);
				
				startY += 70;
			}
		}	
		
		public function deleteUserBtn():void
		{
			for(var i:Number = 0; i<userBtnList.length; i++)
			{
				this.removeChild(userBtnList[i]);
			}
			
			userBtnList.splice(0);	
		}
		
		public function startUserBattle(uid:String):void
		{
			var loader:URLLoader = new URLLoader();
			loader.dataFormat = URLLoaderDataFormat.TEXT;
			loader.addEventListener(Event.COMPLETE, userBattleComplete);
			var url:String = new String;
			url += "http://www.meteorstudio.com/wbgame/userbattle.php";
			url += "?uid=" + uid;
			loader.load(new URLRequest(url));		
		}
		
		private function userBattleComplete(event:Event):void
		{
			deleteUserBtn()
			
			this.gotoAndStop(1, "Info");			
			
			getMyMob();
			getNews();
			createButton();		
		}
	}
}